﻿Public Class Sprite
    Private m_ID As Color

    Shared r As Integer = 0
    Shared g As Integer = 0
    Shared b As Integer = 0

    Private m_pic As Bitmap
    Private m_mask As Bitmap

    Private m_x As Integer
    Private m_y As Integer

    Public Sub New(pic As Bitmap, x As Integer, y As Integer, Optional flipped As Integer = 0)
        Select Case flipped
            Case 0
                ' done
            Case 1
                pic.RotateFlip(RotateFlipType.Rotate90FlipNone)
            Case 2
                pic.RotateFlip(RotateFlipType.Rotate180FlipNone)
            Case 3
                pic.RotateFlip(RotateFlipType.Rotate270FlipNone)
        End Select
        m_pic = pic
        m_mask = New Bitmap(m_pic.Width, m_pic.Height)
        CreateMask()
        m_x = x
        m_y = y
    End Sub

    Private Sub CreateMask()
        m_ID = Color.FromArgb(r, g, b)
        b += 1
        If b > 255 Then
            b = 0
            g += 1
            If g > 255 Then
                g = 0
                r += 1
                If r > 255 Then
                    r = 0
                End If
            End If
        End If
        For y As Integer = 0 To m_mask.Height - 1
            For x As Integer = 0 To m_mask.Width - 1
                If m_pic.GetPixel(x, y).A > 0 Then
                    m_mask.SetPixel(x, y, m_ID)
                End If
            Next
        Next
    End Sub

    Public Sub Draw(g_mask As Graphics, g_view As Graphics)
        g_mask.DrawImage(m_mask, m_x, m_y, m_mask.Width, m_mask.Height)
        g_view.DrawImage(m_pic, m_x, m_y, m_pic.Width, m_pic.Height)
    End Sub

    Public ReadOnly Property ID As Color
        Get
            Return m_ID
        End Get
    End Property

    Public Property x As Integer
        Get
            Return m_x
        End Get
        Set(value As Integer)
            m_x = value
        End Set
    End Property

    Public Property y As Integer
        Get
            Return m_y
        End Get
        Set(value As Integer)
            m_y = value
        End Set
    End Property

    Public ReadOnly Property w As Integer
        Get
            Return m_pic.Width
        End Get
    End Property

    Public ReadOnly Property h As Integer
        Get
            Return m_pic.Height
        End Get
    End Property
End Class