﻿Public Class frmMain
    Dim lastKeyDown As Keys = Keys.None

    Dim bm_HaveInvItems As New Bitmap(assetPath & "HaveInvItems.png")
    Dim bm_HaveDroppedItems As New Bitmap(assetPath & "HaveDroppedItems.png")

    Dim bHaveInvItems As Boolean = False
    Dim bHaveDroppedItems As Boolean = False

    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        txtOutput.Visible = False

        Select Case scl
            Case 1
                Me.Location = New Point((Screen.AllScreens(0).WorkingArea.Width \ 2) - (w \ 2), (Screen.AllScreens(0).WorkingArea.Height \ 2) - (h \ 2))
                Me.Size = New Size(w, h)
            Case 2
                Me.Location = New Point(0, 0)
                Me.Size = New Size(w * scl, h * scl)
        End Select

        Player_CMD = CMD.Take

        LoadRooms()
        UpdateRoom()
    End Sub

    Private Sub pbScreen_Paint(sender As Object, e As PaintEventArgs) Handles pbScreen.Paint
        e.Graphics.PixelOffsetMode = Drawing2D.PixelOffsetMode.Half
        e.Graphics.InterpolationMode = Drawing2D.InterpolationMode.NearestNeighbor

        e.Graphics.DrawImage(screenView, 0, 0, w * scl, h * scl)

        If bHaveInvItems Then
            e.Graphics.DrawImage(bm_HaveInvItems, 10 * scl, 462 * scl, 68 * scl, 68 * scl)
        End If
        If bHaveDroppedItems Then
            e.Graphics.DrawImage(bm_HaveDroppedItems, (68 + 20) * scl, 462 * scl, 68 * scl, 68 * scl)
        End If

        If bInvVisible Then
            e.Graphics.DrawImage(InvView, Inv_x * scl, Inv_y * scl, InvView.Width * scl, InvView.Height * scl)
        End If
        If bDroppedItemsVisible Then
            e.Graphics.DrawImage(DroppedItemsView, DroppedItems_x * scl, DroppedItems_y * scl, DroppedItemsView.Width * scl, DroppedItemsView.Height * scl)
        End If

        If bTxtOutputVisible Then
            e.Graphics.DrawImage(TxtOutputView, TxtOutput_x * scl, TxtOutput_y * scl, TxtOutputView.Width * scl, TxtOutputView.Height * scl)
        End If

        e.Graphics.FillRectangle(Brushes.DarkGreen, (w - 102) * scl, 8 * scl, 164, 40)
        e.Graphics.DrawString("CMD: " & Player_CMD.ToString, New Font("Courier New", 20), Brushes.White, (w - 100) * scl, 10 * scl)
    End Sub

    Private Sub frmMain_MouseWheel(sender As Object, e As MouseEventArgs) Handles Me.MouseWheel
        Static delay As Integer = 0
        delay += 1
        If delay > 0 Then
            Dim i As Integer = CType(Player_CMD, Integer)
            i += 1
            If i > 1 Then
                i = 0
            End If
            Player_CMD = CType(i, CMD)
            delay = 0
        End If
        pbScreen.Refresh()
    End Sub

    Private Sub frmMain_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        If lastKeyDown <> e.KeyCode Then
            lastKeyDown = e.KeyCode

            Select Case e.KeyCode
                Case Keys.D
                    bDroppedItemsVisible = Not bDroppedItemsVisible
                    If bDroppedItemsVisible Then
                        bInvVisible = False
                        UpdateDroppedItems()
                    End If
                    pbScreen.Refresh()
                Case Keys.I
                    bInvVisible = Not bInvVisible
                    If bInvVisible Then
                        bDroppedItemsVisible = False
                        UpdateInv()
                    End If
                    pbScreen.Refresh()
                Case Keys.Space
                    txtOutput.Visible = Not txtOutput.Visible
                    bTxtOutputVisible = Not bTxtOutputVisible
                    UpdateTxtOutput()
                    pbScreen.Refresh()
            End Select
        End If
    End Sub

    Private Sub frmMain_KeyUp(sender As Object, e As KeyEventArgs) Handles Me.KeyUp
        If lastKeyDown = e.KeyCode Then
            lastKeyDown = Keys.None
        End If
    End Sub

    Private Sub pbScreen_MouseDown(sender As Object, e As MouseEventArgs) Handles pbScreen.MouseDown
        If pbScreen.ClientRectangle.Contains(e.Location) Then
            If MouseButtons = MouseButtons.Left Then
                Dim tmp_ID As Color
                If bInvVisible Then
                    Dim tmp_rec As New Rectangle(Inv_x * scl, Inv_y * scl, bmInv.Width * scl, bmInv.Height * scl)
                    If tmp_rec.Contains(e.Location) Then
                        tmp_ID = InvMask.GetPixel((e.X \ scl) - Inv_x, (e.Y \ scl) - Inv_y)
                        With Rooms(currentRoom)
                            Dim bDone As Boolean = False
                            For Each gi As GameItem In Player.Inv
                                If tmp_ID = gi.ID Then
                                    If Player_CMD = CMD.Drop Then
                                        If .DroppedItems.Count < 3 Then
                                            .DroppedItems.Add(gi)
                                            UpdateDroppedItems()
                                            bDone = True
                                            Exit For
                                        End If
                                    End If
                                End If
                            Next
                            If bDone Then
                                spriteToFind = tmp_ID
                                Player.Inv.Remove(Player.Inv.Find(AddressOf FindSprite))
                                UpdateInv()
                                UpdateRoom()
                            End If
                        End With
                    End If
                ElseIf bDroppedItemsVisible Then
                    Dim tmp_rec As New Rectangle(DroppedItems_x * scl, DroppedItems_y * scl, bmDroppedItems.Width * scl, bmDroppedItems.Height * scl)
                    If tmp_rec.Contains(e.Location) Then
                        tmp_ID = DroppedItemsMask.GetPixel((e.X \ scl) - DroppedItems_x, (e.Y \ scl) - DroppedItems_y)
                        With Rooms(currentRoom)
                            Dim bDone As Boolean = False
                            For Each gi As GameItem In .DroppedItems
                                If tmp_ID = gi.ID Then
                                    If Player_CMD = CMD.Take Then
                                        If Player.Inv.Count < 6 Then
                                            Player.Inv.Add(gi)
                                            UpdateInv()
                                            bDone = True
                                            Exit For
                                        End If
                                    End If
                                End If
                            Next
                            If bDone Then
                                spriteToFind = tmp_ID
                                .DroppedItems.Remove(Player.Inv.Find(AddressOf FindSprite))
                                UpdateDroppedItems()
                                UpdateRoom()
                            End If
                        End With
                    End If
                ElseIf bInvVisible = False And bDroppedItemsVisible = False Then
                    tmp_ID = screenMask.GetPixel(e.X \ scl, e.Y \ scl)
                    With Rooms(currentRoom)
                        Dim bDone As Boolean = False
                        If bDone = False Then
                            For Each re As RoomExit In .Exits
                                If tmp_ID = re.ID Then
                                    currentRoom = re.ToRoom
                                    UpdateRoom()
                                    bDone = True
                                    Exit For
                                End If
                            Next
                        End If
                        If bDone = False Then
                            For Each gi As GameItem In .GameItems
                                If tmp_ID = gi.ID Then
                                    If Player_CMD = CMD.Take Then
                                        If Player.Inv.Count < 6 Then
                                            Player.Inv.Add(gi)
                                            .GameItems.Remove(gi)
                                            UpdateInv()
                                            UpdateRoom()
                                        End If
                                    End If
                                    bDone = True
                                    Exit For
                                End If
                            Next
                        End If
                    End With
                End If
                Dim rec_HaveInvItems As New Rectangle(10 * scl, 462 * scl, 68 * scl, 68 * scl)
                If rec_HaveInvItems.Contains(e.Location) Then
                    If bHaveInvItems Then
                        bInvVisible = Not bInvVisible
                        bDroppedItemsVisible = False
                        UpdateInv()
                        pbScreen.Refresh()
                    End If
                End If
                Dim rec_HaveDroppedItems As New Rectangle((68 + 20) * scl, 462 * scl, 68 * scl, 68 * scl)
                If rec_HaveDroppedItems.Contains(e.Location) Then
                    If bHaveDroppedItems Then
                        bDroppedItemsVisible = Not bDroppedItemsVisible
                        bInvVisible = False
                        UpdateDroppedItems()
                        pbScreen.Refresh()
                    End If
                End If
            End If
        End If
    End Sub

#Region "UI"

    Public w As Integer = 960
    Public h As Integer = 540

    Dim scl As Integer = 2

    ' Screen
    Dim screenView As New Bitmap(w, h)
    Public g_screenView As Graphics = Graphics.FromImage(screenView)
    Dim screenMask As New Bitmap(w, h)
    Public g_screenMask As Graphics = Graphics.FromImage(screenMask)

#End Region

#Region "UI"

    ' Inv

    Dim bInvVisible As Boolean = False

    Dim Inv_x As Integer = 180
    Dim Inv_y As Integer = 50

    Dim bmInv As New Bitmap(assetPath & "ui_Inv.png")

    Dim InvView As New Bitmap(bmInv.Width, bmInv.Height)
    Dim g_InvView As Graphics = Graphics.FromImage(InvView)
    Dim InvMask As New Bitmap(bmInv.Width, bmInv.Height)
    Dim g_InvMask As Graphics = Graphics.FromImage(InvMask)

    Public Sub UpdateInv()
        g_InvMask.Clear(Color.Transparent)
        g_InvView.DrawImage(bmInv, 0, 0, bmInv.Width, bmInv.Height)

        Dim count As Integer = 0

        Dim tmp_x As Integer = 20
        Dim tmp_y As Integer = 20

        Dim offset_x As Integer
        Dim offset_y As Integer

        For Each gi As GameItem In Player.Inv
            offset_x = (150 \ 2) - (gi.w \ 2)
            offset_y = (110 \ 2) - (gi.h \ 2)
            gi.x = tmp_x + offset_x
            gi.y = tmp_y + offset_y
            gi.Draw(g_InvMask, g_InvView)
            g_InvView.DrawString(gi.Name, New Font("Arial", 10), Brushes.Black, (gi.x + 150) - offset_x, (gi.y + 45) - offset_y)
            tmp_y += 145
            count += 1
            If count > 2 Then
                count = 0
                tmp_y = 20
                tmp_x = 300
            End If
        Next

        If Player.Inv.Count > 0 Then
            bHaveInvItems = True
        Else
            bHaveInvItems = False
            bInvVisible = False
        End If
    End Sub

    ' DroppedItems

    Dim bDroppedItemsVisible As Boolean = False

    Dim DroppedItems_x As Integer = 0
    Dim DroppedItems_y As Integer = 0

    Dim bmDroppedItems As New Bitmap(assetPath & "ui_DroppedItems.png")

    Dim DroppedItemsView As New Bitmap(bmDroppedItems.Width, bmDroppedItems.Height)
    Dim g_DroppedItemsView As Graphics = Graphics.FromImage(DroppedItemsView)
    Dim DroppedItemsMask As New Bitmap(bmDroppedItems.Width, bmDroppedItems.Height)
    Dim g_DroppedItemsMask As Graphics = Graphics.FromImage(DroppedItemsMask)

    Public Sub UpdateDroppedItems()
        g_DroppedItemsMask.Clear(Color.Transparent)
        g_DroppedItemsView.DrawImage(bmDroppedItems, 0, 0, bmDroppedItems.Width, bmDroppedItems.Height)

        Dim count As Integer = 0

        Dim tmp_x As Integer = 20
        Dim tmp_y As Integer = 20

        Dim offset_x As Integer
        Dim offset_y As Integer

        For Each gi As GameItem In Rooms(currentRoom).DroppedItems
            offset_x = (150 \ 2) - (gi.w \ 2)
            offset_y = (110 \ 2) - (gi.h \ 2)
            gi.x = tmp_x + offset_x
            gi.y = tmp_y + offset_y
            gi.Draw(g_DroppedItemsMask, g_DroppedItemsView)
            g_DroppedItemsView.DrawString(gi.Name, New Font("Arial", 10), Brushes.Black, (gi.x + 150) - offset_x, (gi.y + 45) - offset_y)
            tmp_y += 145
            count += 1
        Next

        If Rooms(currentRoom).DroppedItems.Count > 0 Then
            bHaveDroppedItems = True
        Else
            bHaveDroppedItems = False
            bDroppedItemsVisible = False
        End If
    End Sub

    ' TextOutput

    Dim bmTxtOutput As New Bitmap(assetPath & "ui_TxtOutput.png")

    Dim TxtOutput_x As Integer = 100
    Dim TxtOutput_y As Integer = 380

    Dim TxtOutputView As New Bitmap(bmTxtOutput.Width, bmTxtOutput.Height)
    Dim g_TxtOutputView As Graphics = Graphics.FromImage(TxtOutputView)
    Dim TxtOutputMask As New Bitmap(bmTxtOutput.Width, bmTxtOutput.Height)
    Dim g_TxtOutputMask As Graphics = Graphics.FromImage(TxtOutputMask)

    Dim bTxtOutputVisible As Boolean = False

    Public current_TO As String = ""

    Public Sub UpdateTxtOutput()
        If txtOutput.Visible Then
            txtOutput.Text = current_TO
            g_TxtOutputView.DrawImage(bmTxtOutput, 0, 0, bmTxtOutput.Width, bmTxtOutput.Height)
        End If
    End Sub

#End Region

End Class
