﻿Module modMain
    Public assetPath As String = "..\..\pics\"

    Public Rooms As New List(Of Room)
    Public currentRoom As New Integer

    Public Player As New NPC("Me", New Bitmap(assetPath & "NPC_none.png"), 0, 0)
    Public Player_CMD As CMD = CMD.Take

    Public Sub LoadRooms()
        Dim r As Room
        Dim re As RoomExit
        Dim gi As GameItem
        Dim n As NPC

        ' 0
        r = New Room(New Bitmap(assetPath & "bg_Main.png"), "A maze like part of the city.")
        re = New RoomExit(4, New Bitmap(assetPath & "GoTo.png"), 10, 370, 2)
        r.Exits.Add(re)
        re = New RoomExit(1, New Bitmap(assetPath & "GoTo.png"), 700, 10)
        r.Exits.Add(re)
        gi = New GameItem("Stamp of Sunrise", New Bitmap(assetPath & "item_stamp.png"), 260, 340)
        r.GameItems.Add(gi)
        Rooms.Add(r)
        r = Nothing

        ' 1
        r = New Room(New Bitmap(assetPath & "bg_UpTheStreet.png"), "A convenience store on a very empty street.")
        re = New RoomExit(0, New Bitmap(assetPath & "GoTo.png"), 20, 250, 2)
        r.Exits.Add(re)
        re = New RoomExit(2, New Bitmap(assetPath & "GoTo.png"), 690, 20)
        r.Exits.Add(re)
        re = New RoomExit(3, New Bitmap(assetPath & "GoInOut.png"), 454, 120)
        r.Exits.Add(re)
        gi = New GameItem("Document", New Bitmap(assetPath & "item_Document.png"), 290, 170)
        r.GameItems.Add(gi)
        n = New NPC("Some NPC", New Bitmap(assetPath & "NPC.png"), 440, 40)
        r.NPCs.Add(n)
        Rooms.Add(r)
        r = Nothing

        ' 2
        r = New Room(New Bitmap(assetPath & "bg_SideStreet.png"), "Secluded and not looking too safe.")
        re = New RoomExit(1, New Bitmap(assetPath & "GoTo.png"), 460, 440, 2)
        r.Exits.Add(re)
        re = New RoomExit(3, New Bitmap(assetPath & "GoInOut.png"), 20, 50, 2)
        r.Exits.Add(re)
        re = New RoomExit(5, New Bitmap(assetPath & "GoTo.png"), 840, 40)
        r.Exits.Add(re)
        gi = New GameItem("Bottle", New Bitmap(assetPath & "item_Bottle.png"), 230, 70)
        r.GameItems.Add(gi)
        Rooms.Add(r)
        r = Nothing

        ' 3
        r = New Room(New Bitmap(assetPath & "bg_InsideStore.png"), "A quiet computer store.")
        re = New RoomExit(1, New Bitmap(assetPath & "GoInOut.png"), 760, 440, 2)
        r.Exits.Add(re)
        re = New RoomExit(2, New Bitmap(assetPath & "GoInOut.png"), 454, 40)
        r.Exits.Add(re)
        gi = New GameItem("Keycard", New Bitmap(assetPath & "item_Keycard.png"), 230, 70)
        r.GameItems.Add(gi)
        Rooms.Add(r)
        r = Nothing

        ' 4
        r = New Room(New Bitmap(assetPath & "bg_BackParking.png"), "There are no cars here today.")
        re = New RoomExit(0, New Bitmap(assetPath & "GoTo.png"), 820, 10)
        r.Exits.Add(re)
        re = New RoomExit(6, New Bitmap(assetPath & "GoTo.png"), 10, 40, 2)
        r.Exits.Add(re)
        gi = New GameItem("Pencil", New Bitmap(assetPath & "item_pencil.png"), 30, 260)
        r.GameItems.Add(gi)
        Rooms.Add(r)
        r = Nothing

        ' 5
        r = New Room(New Bitmap(assetPath & "bg_RearEntrance.png"), "The entrance to the ...establishment.")
        re = New RoomExit(2, New Bitmap(assetPath & "GoTo.png"), 20, 240, 2)
        r.Exits.Add(re)
        gi = New GameItem("Gold coin", New Bitmap(assetPath & "item_coin.png"), 610, 210)
        r.GameItems.Add(gi)
        gi = New GameItem("Envelope", New Bitmap(assetPath & "item_Envelope.png"), 410, 190)
        r.GameItems.Add(gi)
        n = New NPC("Other NPC", New Bitmap(assetPath & "NPC2.png"), 440, 40)
        r.NPCs.Add(n)
        Rooms.Add(r)
        r = Nothing

        ' 6
        r = New Room(New Bitmap(assetPath & "bg_HighRise.png"), "The tower with the safe at the top.")
        re = New RoomExit(4, New Bitmap(assetPath & "GoTo.png"), 790, 410)
        r.Exits.Add(re)
        n = New NPC("Cool NPC", New Bitmap(assetPath & "NPC3.png"), 200, 80)
        r.NPCs.Add(n)
        Rooms.Add(r)
        r = Nothing

        currentRoom = 0
    End Sub

    Public Sub UpdateRoom()
        frmMain.g_screenMask.Clear(Color.Transparent)

        With Rooms(currentRoom)
            frmMain.g_screenView.DrawImage(.Background, 0, 0, frmMain.w, frmMain.h)

            For Each re As RoomExit In .Exits
                re.Draw(frmMain.g_screenMask, frmMain.g_screenView)
            Next

            Dim tmp_s As String = ""
            For Each gi As GameItem In .GameItems
                gi.Draw(frmMain.g_screenMask, frmMain.g_screenView)
                tmp_s += gi.Name & ", "
            Next

            Dim tmp_s2 As String = ""
            For Each n As NPC In .NPCs
                n.Draw(frmMain.g_screenMask, frmMain.g_screenView)
                tmp_s2 += n.Name & ", "
            Next

            frmMain.current_TO = .Description & vbCrLf & vbCrLf & "There is: " & tmp_s & " here."
            If .NPCs.Count > 0 Then
                frmMain.current_TO += vbCrLf & tmp_s2 & " are also here."
            End If

            frmMain.UpdateTxtOutput()
        End With

        frmMain.UpdateInv()
        frmMain.UpdateDroppedItems()

        frmMain.pbScreen.Refresh()
    End Sub

#Region "Find Functions"

    Public spriteToFind As Color

    Public Function FindSprite(s As Sprite) As Boolean
        If spriteToFind = s.ID Then
            Return True
        Else
            Return False
        End If
    End Function

#End Region

End Module

Public Enum CMD
    Take = 0
    Drop = 1
End Enum